{***************************************************************
 *
 * Unit Name: uMain
 * Purpose  : this is an example of how to use the TCrossGrid component.
 *          : This demo makes use of the DBDemos Database distributed with
 *          : Borland Delphi. Without DBDEMOS AND BDE installed, this demo can not work !
 * Author   : Samuel Herzog ( sam_herzog@yahoo.com )
 * History  :
 *
 ****************************************************************}

unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, CCrossDB, StdCtrls;

type
  TFMain = class(TForm)
    CrossGrid1: TCrossGrid;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CrossGrid1FieldZDraw(Sender: TObject; var _Value: String;ARect: TRect; ACol, Arow: Integer; AState: TGridDrawState);
    procedure CrossGrid1FieldXDraw(Sender: TObject; var _Value: String;
      ARect: TRect; ACol, ARow: Integer; AState: TGridDrawState);
    procedure CrossGrid1FieldYDraw(Sender: TObject; var _Value: String;
      ARect: TRect; ACol, ARow: Integer; AState: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FMain: TFMain;

implementation

uses uAppData;

{$R *.DFM}

procedure TFMain.Button1Click(Sender: TObject);
begin
  if MessageDlg('You need to have the Borland Example database "DBDemos" installed '+#13+#10+'to run this demo.', mtInformation, [mbOK, mbCancel], 0)=mrOk then begin
    AppData.PartQuery.open;
    AppData.OrderQuery.open;
    AppData.ItemQuery.open;
    crossgrid1.Active:=True;
    crossgrid1.ColWidths[0]:=40;
    crossgrid1.ColWidths[1]:=140;
    crossgrid1.ColWidths[2]:=80;
  end;  
end;

procedure TFMain.Button2Click(Sender: TObject);
begin
  crossgrid1.Active:=False;
  AppData.PartQuery.close;
  AppData.OrderQuery.close;
  AppData.ItemQuery.close;
end;

//*************************************************************************
//Procedure: TForm1.CrossGrid1FieldZDraw
//Description: if you want to paint the content of a field by yourself, then
// it may look like this example.
//Author: SH
//History: 29.10.2001 19:01:49
//*************************************************************************
procedure TFMain.CrossGrid1FieldZDraw(Sender: TObject; var _Value: String;ARect: TRect; ACol, Arow: Integer; AState: TGridDrawState);
begin
  if _Value='' then exit;
  with CrossGrid1.Canvas do begin
    if StrToInt(_Value)>30 then Brush.color:=clred else
    if StrToInt(_Value)>5  then Brush.color:=clgreen
                           else Brush.color:=clwhite;
    Font.Style:=[fsBold];
    FillRect(ARect);       // change the field background according to the field content <_value>.
    Crossgrid1.DrawRect(_Value,Arect,ACol,ARow,AState);
  end;
end;

//*************************************************************************
//Procedure: TForm1.CrossGrid1FieldXDraw
//Description:
//Author: SH
//History: 29.10.2001 20:20:49
//*************************************************************************
procedure TFMain.CrossGrid1FieldXDraw(Sender: TObject; var _Value: String;ARect: TRect; ACol, ARow: Integer; AState: TGridDrawState);
begin
  if _Value='' then exit;
  CrossGrid1.Canvas.Font.Style:=[fsBold]; // set to bold font.
  Crossgrid1.DrawRect(_Value,Arect,ACol,ARow,AState);
end;


//*************************************************************************
//Procedure: TForm1.CrossGrid1FieldYDraw
//Description:
//Author: SH
//History: 29.10.2001 20:23:48
//*************************************************************************
procedure TFMain.CrossGrid1FieldYDraw(Sender: TObject; var _Value: String;  ARect: TRect; ACol, ARow: Integer; AState: TGridDrawState);
begin
  if _Value='' then exit;
  with CrossGrid1.Canvas do begin
    if ACol=0 then Font.Style:=[fsBold]
              else Font.Style:=[];
    Crossgrid1.DrawRect(_Value,Arect,ACol,ARow,AState);
  end;
end;

end.
